

        DOSSEG
        .MODEL small

         include c:dos.inc
         include c:bios.inc

        .DATA

;******************PORTS

        DATAPORT EQU 330H
        COMPORT EQU 331H
        STATPORT EQU 331H

;******************MASKS

        DRR EQU 40H
        DSR EQU 80H


        .CODE

Public Send_command,Drr_rout,Dsr_rout,Ackno_Rout
Extrn Read_Data:near

;Procedure  Send_Command
;Purpose  Sends a command to the MPU
;Input  Command in AL


Send_Command Proc
        push dx
        push ax          ;save command in AL
SCM1:
        mov dx,statport
        in al,dx
        and al,DRR       ;Is Mpu ready to receive data?
        jz SCM2          ;Yes continue, else wait
        jmp SCM1
SCM2:
        pop ax
        mov dx,comport
        out dx,al       ;send command
SCM3:
        mov dx,statport
        in al,dx
        and al,DSR      ;is mpu Data set ready
        jz SCM4         ;Yes, continue, else wait
        jmp SCM3
SCM4:
        call ackno_rout   ;Check if it is acknowledge
        pop dx
        ret
Send_Command Endp


;Procedure Drr_Rout
;Purpose  Waits for MPU to be ready receive data

Drr_Rout Proc
        push ax
        push dx
loop_drr:
        mov dx,statport
        in al,dx
        and al,DRR      ;AL and Drr mask=0 if ready to receive data
        jz DRR_ok       ;Ready? then exit
        jmp loop_drr    ;Else wait
DRR_OK:
        pop dx
        pop ax
        ret
Drr_Rout endp

;Procedure Dsr_Rout
;Purpose  Checks if MPU is ready to send data

Dsr_Rout Proc
        push ax
        push dx
        clc
        mov dx,statport
        in al,dx
        and al,Dsr      ;AL and Dsr mask = 0 if data set is ready
        jz Dsr_ok       ;Dsr exit
        stc             ;else set carry flag
Dsr_ok:
        pop dx
        pop ax
        ret
Dsr_Rout endp

;Procedure  Ackno_Rout
;Purpose  Waits for acknowledge from MPU

Ackno_Rout Proc
        push ax
        push dx
ackno_loop:
        mov dx,dataport
        in al,dx
        cmp al,0feh     ;Is data from MPU acknowledge? (0FEH)
        je ackno_ok     ;Yes? exit
        call read_data  ;Else read data from MPU until acknowledge is received
        jmp ackno_loop
ackno_ok:
        pop dx
        pop ax
        ret
Ackno_Rout Endp

        end
