


        DOSSEG
        .MODEL small

         include c:dos.inc
         include c:bios.inc


        .DATA

Extrn Sr_menu:byte,col2:byte

;******************PORTS

        DATAPORT EQU 330H
        COMPORT EQU 331H
        STATPORT EQU 331H

;******************MASKS

        DRR EQU 40H     ;Data receive ready mask
        DSR EQU 80H     ;Data send ready mask

;******************COMMANDS

        DsOn equ 8bh    ;Data in stop mode ON
        DsOf equ 8ah    ;Data in stop mode OFF
        ExOn equ 97h    ;Exclusive to host ON
        ExOf equ 96h    ;Exclusive to host OFF
        WsEx equ 0dfh   ;Want to send System Exclusive message

;******************DATA BUFFER and variables

        Buffer_pt dw 0  ;points to free area in buffer
        data_buffer dw 0  ;holds segment of buffer
        Sze_Buffer  dw 0  ;Size of memory block allocated by DOS

;****************Files control and buffers

        Hdle dw 0
        Datafile_Bf DB 40,0,0
        Datafile db 40 dup (20h),0   ;name of file
        Sze         dw 0             ;Sze in bytes of file


        .CODE

Public SendRec

Extrn Send_command:near,Dsr_rout:near,Disp_SrMenu:near
Extrn Clear_bf:near,Rready:near,Receiving:near,RecOk:near,error:near
Extrn File_box:near,write:near,keyb:near,Drr_rout:near


;Procedure SendRec
;Purpose Display Send/Rec menu and calls a procedure acording to users choice

SendRec proc
        push ax
        push si
        call Disp_Srmenu        ;(LI.LIB) Display and selecy option
        jc ExitSr
        lea si,Sr_menu
        cmp byte ptr [si+2],1   ;if equal
        jne Sr1
        call SendData           ;want to send data
        jmp ExitSr
Sr1:
        call ReceiveData        ;Else want to receive data
ExitSr:
        mov ah,1
        int 16h
        jz ExitSr2              ;if not zero a key was pressed to
FKey:                           ;stop procedure
        mov ah,7
        int 21h                 ;clear buffer with DOS
        cmp al,0                ;if AL=0 a function key was pressed
        je FKey                 ;clear buffer
ExitSr2:
        pop si
        pop ax
        ret
SendRec endp

;Procedure Receive Data
;Purpose  Receive data dump from synth.

ReceiveData proc
        push ax
        push bx
        push cx
        push dx
        push di
        push es
        @GetBlok 0fffh          ;ask DOS for 64K block for buffer
        mov es,ax
        mov cl,4
        shl bx,cl               ;allocated block(in paragraphs)*16=total bytes
        mov Sze_buffer,bx       ;allocated, into Sze_buffer
        call File_box           ;draw box for entering filename
        lea si,DataFile
        mov ax,0
        mov bl,col2
        mov ch,15
        mov cl,28
        call WRITE              ;(LI.LIB) write previous filename
        mov ah,2
        mov bh,0
        mov dh,15
        mov dl,28
        int 10h                 ;position cursor
        lea dx,DataFile_BF
        mov bl,COL2
        call KEYB               ;wait for input
        mov si,dx
        cmp [si+1],byte ptr 0ffh
        jne Rd1                    ;if not equal to 0ffh, OK
        lea di,Datafile            ;else ESC was pressed
        call CLEAR_BF              ;clear buffer and exit
        jmp ExitRd
Rd1:
        mov al,DsOn                ;Data in stop mode on
        call SEND_COMMAND
        mov al,ExOn                ;Exclusive to host on
        call Send_Command
        call Rready                ;Display ready to receive data message
        cld
Rd2:
        call Dsr_rout             ;Is data set ready?
        jnc Data_ready            ;if carry not set we have data
        mov ah,1                  ;Key pressed?
        int 16h
        jz Rd2                    ;no?, wait for data
        jmp ExitRd                ;else EXIT
Data_ready:
        mov dx,Dataport
        in al,dx
        cmp al,0ffh               ;if data <> 0ffh then is not a System exclusive
        jne Rd2                   ;message, continue wait for data
        call Receiving            ;Else display message Receiving data
Data_ready2:
        mov di,buffer_pt
        mov dx,dataport
        in al,dx                  ;store data in buffer
        cmp al,0f7h               ;if data=0F7h (End Of eXclusive)
        je End_data               ;we are at end of message
        stosb
        inc buffer_pt             ;else increase pointer into buffer
        inc sze                   ;increase size of file
        cmp di,Sze_Buffer         ;check for data buffer overflow
        jbe Data_ready3
        mov ax,101
        call error
        jmp ExitRd
Data_ready3:
        call Dsr_rout             ;More data?
        jnc Data_ready2           ;Loop
        mov ah,1
        int 16h
        jz Data_ready3            ;else wait
        jmp ExitRd                ;if key is pressed Exit
End_data:
        stosb                    ;save End Of eXclusive in buffer
        inc sze                  ;increase size of file
NoMore:
        call RecOk               ;Display message Procedure complete
        @makfil DataFile         ;make file
        jnc Rd3
        call Error
        jmp ExitRd
Rd3:
        mov hdle,ax
        mov bx,ax                ;write data to file
        mov ah,40h
        mov cx,Sze
        xor dx,dx
        push ds
        push es                 ;make DS point to buffer
        pop ds
        int 21h
        pop ds
        cmp ax,cx               ;Write problem?
        je Rd4
        mov ax,99
        call ERROR
Rd4:
        @closfil hdle           ;Close file
ExitRd:
        mov ah,49h              ;Free allocated block of memory
        int 21h
        mov al,ExOf             ;Exclusive to host off
        call Send_Command
        mov al,DsOf             ;Data in stop mode off
        call Send_Command
        mov buffer_pt,0         ;reset buffer pointer for next call
        mov sze,0               ;set size to 0
        @SetCurPos 0,25,0       ;move cursor out of screen
        pop es
        pop di
        pop dx
        pop cx
        pop bx
        pop ax
        ret
ReceiveData endp

;Procedure SenData
;Purpose  Send data to synth.

SendData proc
        push ax
        push bx
        push cx
        push dx
        push di
        push es
        call File_box      ;Display box for entering filename
        lea si,DataFile
        mov ax,0
        mov bl,col2
        mov ch,15
        mov cl,28
        call WRITE         ;Write previous filename
        mov ah,2
        mov bh,0
        mov dh,15
        mov dl,28
        int 10h           ;Position cursor
        lea dx,DataFile_BF
        mov bl,COL2
        call KEYB          ;wait for input
        mov si,dx
        cmp [si+1],byte ptr 0ffh
        jne Sn1               ;Not equal? Ok
        lea di,Datafile       ;Else clear buffer
        call CLEAR_BF
        jmp ExitSn2           ;Exit
Sn1:
        @OpenFil DataFile,0    ;Open file
        jnc Sn2
        call ERROR
        jmp ExitSn
Sn2:
        mov hdle,ax
        @GetFilSz hdle          ;Get file size
        cmp dx,0                ;If bigger than 64K
        je Sn3
        mov ax,101              ;Exit
        call Error
        jmp ExitSn2
Sn3:
        mov sze,ax
        @GetBlok ax             ;Get buffer for file from DOS
        mov es,ax
        cmp bx,sze              ;if allocated block is smaller than file
        je Sn3a                 ;size then exit with error message
        mov ax,103
        call ERROR
        jmp ExitSn
Sn3a:
        mov bx,hdle
        mov ah,3fh
        mov cx,sze
        xor dx,dx               ;else read data
        push ds
        push es
        pop ds
        int 21h
        pop ds
        cmp ax,cx
        je Sn4
        mov ax,100
        call ERROR
        jmp ExitSn
Sn4:
        @closfil hdle           ;close file
        xor si,si
        mov al,WsEx             ;Want to send system exclusive message
        call send_command
        mov dx,dataport
Loop_Sd:
        call Drr_rout
        mov al,es:[si]
        inc si
        out dx,al
        cmp al,0f7h             ;Send data from buffer until End Of eXclusive
        jne loop_Sd             ;found
ExitSn:
        mov ah,49h              ;free allocated memory
        int 21h
ExitSn2:
        mov sze,0               ;set file size to 0
        @SetCurPos 0,25,0       ;move cursor out of screen
        pop es
        pop di
        pop dx
        pop cx
        pop bx
        pop ax
        ret
SendData endp


        end

